diff --git a/sql/sql_db.cc b/sql/sql_db.cc
index a930cb0..7cffb8b 100644
--- a/sql/sql_db.cc
+++ b/sql/sql_db.cc
@@ -39,6 +39,9 @@
 #include "events.h"
 #include "sql_handler.h"
 #include "sql_statistics.h"
+#include "rpl_filter.h"
+#include "rpl_rli.h"
+
 #include <my_dir.h>
 #include <m_ctype.h>
 #include "log.h"
@@ -233,7 +236,7 @@ void my_dbopt_cleanup(void)
     1 on error.
 */
 
-static my_bool get_dbopt(const char *dbname, HA_CREATE_INFO *create)
+static my_bool get_dbopt(const char *dbname, Schema_specification_st *create)
 {
   my_dbopt_t *opt;
   uint length;
@@ -264,7 +267,7 @@ static my_bool get_dbopt(const char *dbname, HA_CREATE_INFO *create)
     1 on error.
 */
 
-static my_bool put_dbopt(const char *dbname, HA_CREATE_INFO *create)
+static my_bool put_dbopt(const char *dbname, Schema_specification_st *create)
 {
   my_dbopt_t *opt;
   uint length;
@@ -333,7 +336,8 @@ static void del_dbopt(const char *path)
   1	Could not create file or write to it.  Error sent through my_error()
 */
 
-static bool write_db_opt(THD *thd, const char *path, HA_CREATE_INFO *create)
+static bool write_db_opt(THD *thd, const char *path,
+                         Schema_specification_st *create)
 {
   register File file;
   char buf[256]; // Should be enough for one option
@@ -379,7 +383,7 @@ static bool write_db_opt(THD *thd, const char *path, HA_CREATE_INFO *create)
 
 */
 
-bool load_db_opt(THD *thd, const char *path, HA_CREATE_INFO *create)
+bool load_db_opt(THD *thd, const char *path, Schema_specification_st *create)
 {
   File file;
   char buf[256];
@@ -491,7 +495,7 @@ bool load_db_opt(THD *thd, const char *path, HA_CREATE_INFO *create)
 */
 
 bool load_db_opt_by_name(THD *thd, const char *db_name,
-                         HA_CREATE_INFO *db_create_info)
+                         Schema_specification_st *db_create_info)
 {
   char db_opt_path[FN_REFLEN + 1];
 
@@ -518,7 +522,7 @@ bool load_db_opt_by_name(THD *thd, const char *db_name,
 
 CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name)
 {
-  HA_CREATE_INFO db_info;
+  Schema_specification_st db_info;
 
   if (thd->db != NULL && strcmp(db_name, thd->db) == 0)
     return thd->db_charset;
@@ -537,14 +541,28 @@ CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name)
 }
 
 
+SQL::Statement::Schema::DDL_options::DDL_options(const LEX *lex)
+{
+  *this= lex->create_info;
+}
+
+
+SQL::Statement::Schema::Specification::Specification(const LEX *lex)
+{
+  *this= lex->create_info;
+}
+
+
+
 /*
   Create a database
 
   SYNOPSIS
-  mysql_create_db()
+  create_db()
   thd		Thread handler
   db		Name of database to create
 		Function assumes that this is already validated.
+  options       DDL options, e.g. IF NOT EXISTS
   create_info	Database create options (like character set)
   silent	Used by replication when internally creating a database.
 		In this case the entry should not be logged.
@@ -560,16 +578,24 @@ CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name)
   TRUE  Error
 
 */
-
-int mysql_create_db(THD *thd, char *db, HA_CREATE_INFO *create_info,
-                     bool silent)
+int
+SQL::Statement::Schema::DDL::create_db(THD *thd,
+                                       const Name &name,
+                                       const DDL_options_st options,
+                                       const Schema_specification_st &spec,
+                                       bool silent) const
 {
   char	 path[FN_REFLEN+16];
   long result= 1;
   int error= 0;
   MY_STAT stat_info;
-  uint create_options= create_info ? create_info->options : 0;
   uint path_len;
+  const char *db= name.name();
+  /*
+    write_db_opt() can modify Schema_specification_st structure passed to it,
+    so make a copy.
+  */
+  Schema_specification_st create_info(spec);
   DBUG_ENTER("mysql_create_db");
 
   /* do not create 'information_schema' db */
@@ -579,7 +605,8 @@ int mysql_create_db(THD *thd, char *db, HA_CREATE_INFO *create_info,
     DBUG_RETURN(-1);
   }
 
-  char db_tmp[SAFE_NAME_LEN], *dbnorm;
+  char db_tmp[SAFE_NAME_LEN];
+  const char *dbnorm;
   if (lower_case_table_names)
   {
     strmake_buf(db_tmp, db);
@@ -598,7 +625,7 @@ int mysql_create_db(THD *thd, char *db, HA_CREATE_INFO *create_info,
 
   if (mysql_file_stat(key_file_misc, path, &stat_info, MYF(0)))
   {
-    if (!(create_options & HA_LEX_CREATE_IF_NOT_EXISTS))
+    if (!options.if_not_exists())
     {
       my_error(ER_DB_CREATE_EXISTS, MYF(0), db);
       error= -1;
@@ -626,7 +653,7 @@ int mysql_create_db(THD *thd, char *db, HA_CREATE_INFO *create_info,
 
   path[path_len-1]= FN_LIBCHAR;
   strmake(path+path_len, MY_DB_OPT_FILE, sizeof(path)-path_len-1);
-  if (write_db_opt(thd, path, create_info))
+  if (write_db_opt(thd, path, &create_info))
   {
     /*
       Could not create options file.
@@ -702,14 +729,19 @@ int mysql_create_db(THD *thd, char *db, HA_CREATE_INFO *create_info,
 
 /* db-name is already validated when we come here */
 
-bool mysql_alter_db(THD *thd, const char *db, HA_CREATE_INFO *create_info)
+bool SQL::Statement::Schema::Alter::exec(THD *thd) const
 {
   char path[FN_REFLEN+16];
   long result=1;
   int error= 0;
+  /*
+    write_db_opt() can modify Schema_specification_st structure passed to it,
+    so make a copy.
+  */
+  Schema_specification_st create_info(*this);
   DBUG_ENTER("mysql_alter_db");
 
-  if (lock_schema_name(thd, db))
+  if (lock_schema_name(thd, name()))
     DBUG_RETURN(TRUE);
 
   /* 
@@ -717,17 +749,15 @@ bool mysql_alter_db(THD *thd, const char *db, HA_CREATE_INFO *create_info)
      We pass MY_DB_OPT_FILE as "extension" to avoid
      "table name to file name" encoding.
   */
-  build_table_filename(path, sizeof(path) - 1, db, "", MY_DB_OPT_FILE, 0);
-  if ((error=write_db_opt(thd, path, create_info)))
+  build_table_filename(path, sizeof(path) - 1, name(), "", MY_DB_OPT_FILE, 0);
+  if ((error=write_db_opt(thd, path, &create_info)))
     goto exit;
 
   /* Change options if current database is being altered. */
 
-  if (thd->db && !strcmp(thd->db,db))
+  if (thd->db && !strcmp(thd->db, name()))
   {
-    thd->db_charset= create_info->default_table_charset ?
-		     create_info->default_table_charset :
-		     thd->variables.collation_server;
+    thd->db_charset= create_info.default_table_charset;
     thd->variables.collation_database= thd->db_charset;
   }
 
@@ -741,8 +771,8 @@ bool mysql_alter_db(THD *thd, const char *db, HA_CREATE_INFO *create_info)
       database" and not the threads current database, which is the
       default.
     */
-    qinfo.db     = db;
-    qinfo.db_len = strlen(db);
+    qinfo.db     = name();
+    qinfo.db_len = strlen(name());
 
     /*
       These DDL methods and logging are protected with the exclusive
@@ -773,7 +803,8 @@ bool mysql_alter_db(THD *thd, const char *db, HA_CREATE_INFO *create_info)
   @retval  true   Error
 */
 
-bool mysql_rm_db(THD *thd,char *db,bool if_exists, bool silent)
+bool SQL::Statement::Schema::DDL::rm_db(THD *thd, const Name &name,
+                                        bool if_exists, bool silent) const
 {
   ulong deleted_tables= 0;
   bool error= true;
@@ -783,6 +814,7 @@ bool mysql_rm_db(THD *thd,char *db,bool if_exists, bool silent)
   TABLE_LIST *tables= NULL;
   TABLE_LIST *table;
   Drop_table_error_handler err_handler;
+  const char *db= name.name();
   DBUG_ENTER("mysql_rm_db");
 
   char db_tmp[SAFE_NAME_LEN], *dbnorm;
@@ -793,7 +825,7 @@ bool mysql_rm_db(THD *thd,char *db,bool if_exists, bool silent)
     dbnorm= db_tmp;
   }
   else
-    dbnorm= db;
+    dbnorm= (char *) db;
 
   if (lock_schema_name(thd, dbnorm))
     DBUG_RETURN(true);
@@ -960,7 +992,8 @@ bool mysql_rm_db(THD *thd,char *db,bool if_exists, bool silent)
           These DDL methods and logging are protected with the exclusive
           metadata lock on the schema.
         */
-        if (write_to_binlog(thd, query, query_pos -1 - query, db, db_len))
+        if (write_to_binlog(thd, query, query_pos -1 - query,
+                            (char *) db, db_len))
         {
           error= true;
           goto exit;
@@ -978,7 +1011,8 @@ bool mysql_rm_db(THD *thd,char *db,bool if_exists, bool silent)
         These DDL methods and logging are protected with the exclusive
         metadata lock on the schema.
       */
-      if (write_to_binlog(thd, query, query_pos -1 - query, db, db_len))
+      if (write_to_binlog(thd, query, query_pos -1 - query,
+                          (char *) db, db_len))
       {
         error= true;
         goto exit;
@@ -1597,20 +1631,20 @@ bool mysql_opt_change_db(THD *thd,
   @param old_db 5.0 database name, in #mysql50#name format
   @return 0 on success, 1 on error
 */
-bool mysql_upgrade_db(THD *thd, LEX_STRING *old_db)
+bool SQL::Statement::Schema::Upgrade::exec(THD *thd) const
 {
   int error= 0, change_to_newdb= 0;
   char path[FN_REFLEN+16];
   uint length;
-  HA_CREATE_INFO create_info;
+  Schema_specification_st create_info;
   MY_DIR *dirp;
   TABLE_LIST *table_list;
   SELECT_LEX *sl= thd->lex->current_select;
   LEX_STRING new_db;
   DBUG_ENTER("mysql_upgrade_db");
 
-  if ((old_db->length <= MYSQL50_TABLE_NAME_PREFIX_LENGTH) ||
-      (strncmp(old_db->str,
+  if ((name_length() <= MYSQL50_TABLE_NAME_PREFIX_LENGTH) ||
+      (strncmp(name(),
               MYSQL50_TABLE_NAME_PREFIX,
               MYSQL50_TABLE_NAME_PREFIX_LENGTH) != 0))
   {
@@ -1621,36 +1655,35 @@ bool mysql_upgrade_db(THD *thd, LEX_STRING *old_db)
   }
 
   /* `#mysql50#<name>` converted to encoded `<name>` */
-  new_db.str= old_db->str + MYSQL50_TABLE_NAME_PREFIX_LENGTH;
-  new_db.length= old_db->length - MYSQL50_TABLE_NAME_PREFIX_LENGTH;
+  new_db.str= (char *) name() + MYSQL50_TABLE_NAME_PREFIX_LENGTH;
+  new_db.length= name_length() - MYSQL50_TABLE_NAME_PREFIX_LENGTH;
 
   /* Lock the old name, the new name will be locked by mysql_create_db().*/
-  if (lock_schema_name(thd, old_db->str))
+  if (lock_schema_name(thd, name()))
     DBUG_RETURN(1);
 
   /*
     Let's remember if we should do "USE newdb" afterwards.
     thd->db will be cleared in mysql_rename_db()
   */
-  if (thd->db && !strcmp(thd->db, old_db->str))
+  if (thd->db && !strcmp(thd->db, name()))
     change_to_newdb= 1;
 
-  build_table_filename(path, sizeof(path)-1,
-                       old_db->str, "", MY_DB_OPT_FILE, 0);
+  build_table_filename(path, sizeof(path)-1, name(), "", MY_DB_OPT_FILE, 0);
   if ((load_db_opt(thd, path, &create_info)))
     create_info.default_table_charset= thd->variables.collation_server;
 
-  length= build_table_filename(path, sizeof(path)-1, old_db->str, "", "", 0);
+  length= build_table_filename(path, sizeof(path)-1, name(), "", "", 0);
   if (length && path[length-1] == FN_LIBCHAR)
     path[length-1]=0;                            // remove ending '\'
   if ((error= my_access(path,F_OK)))
   {
-    my_error(ER_BAD_DB_ERROR, MYF(0), old_db->str);
+    my_error(ER_BAD_DB_ERROR, MYF(0), name());
     goto exit;
   }
 
   /* Step1: Create the new database */
-  if ((error= mysql_create_db(thd, new_db.str, &create_info, 1)))
+  if ((error= create_db(thd, new_db, DDL_options(), create_info, true)))
     goto exit;
 
   /* Step2: Move tables to the new database */
@@ -1675,7 +1708,10 @@ bool mysql_upgrade_db(THD *thd, LEX_STRING *old_db)
       table_str.length= filename_to_tablename(file->name,
                                               tname, sizeof(tname)-1);
       table_str.str= (char*) sql_memdup(tname, table_str.length + 1);
-      Table_ident *old_ident= new Table_ident(thd, *old_db, table_str, 0);
+      LEX_STRING old_db;
+      old_db.str= (char *) name();
+      old_db.length= name_length();
+      Table_ident *old_ident= new Table_ident(thd, old_db, table_str, 0);
       Table_ident *new_ident= new Table_ident(thd, new_db, table_str, 0);
       if (!old_ident || !new_ident ||
           !sl->add_table_to_list(thd, old_ident, NULL,
@@ -1760,7 +1796,7 @@ bool mysql_upgrade_db(THD *thd, LEX_STRING *old_db)
 
       /* pass empty file name, and file->name as extension to avoid encoding */
       build_table_filename(oldname, sizeof(oldname)-1,
-                           old_db->str, "", file->name, 0);
+                           name(), "", file->name, 0);
       build_table_filename(newname, sizeof(newname)-1,
                            new_db.str, "", file->name, 0);
       mysql_file_rename(key_file_misc, oldname, newname, MYF(MY_WME));
@@ -1774,7 +1810,7 @@ bool mysql_upgrade_db(THD *thd, LEX_STRING *old_db)
     to execute them again.
     mysql_rm_db() also "unuses" if we drop the current database.
   */
-  error= mysql_rm_db(thd, old_db->str, 0, 1);
+  error= rm_db(thd, *this, false, true);
 
   /* Step8: logging */
   if (mysql_bin_log.is_open())
@@ -1823,3 +1859,104 @@ bool check_db_dir_existence(const char *db_name)
 
   return my_access(db_dir_path, F_OK);
 }
+
+
+bool SQL::Statement::Schema::Name::check() const
+{
+  LEX_CSTRING tmp= *this;
+  bool check_path_chars;
+  if ((check_path_chars= check_mysql50_prefix(name())))
+  {
+    DBUG_ASSERT(tmp.length >= MYSQL50_TABLE_NAME_PREFIX_LENGTH);
+    tmp.str+= MYSQL50_TABLE_NAME_PREFIX_LENGTH;
+    tmp.length-= MYSQL50_TABLE_NAME_PREFIX_LENGTH;
+  }
+  if (!tmp.length || tmp.length > NAME_LEN)
+    return true;
+
+  if (db_name_is_in_ignore_db_dirs_list(tmp.str))
+    return true;
+
+  return check_table_name(tmp.str, tmp.length, check_path_chars);
+}
+
+
+bool SQL::Statement::Schema::Name::check_with_error() const
+{
+  if (Schema::Name::check())
+  {
+    my_error(ER_WRONG_DB_NAME, MYF(0), name());
+    return true;
+  }
+  return false;
+}
+
+
+#ifdef HAVE_REPLICATION
+bool SQL::Statement::Schema::Name::check_if_slave_ignored(THD *thd) const
+{
+  if (thd->slave_thread)
+  {
+    Rpl_filter *rpl_filter= thd->system_thread_info.rpl_sql_info->rpl_filter;
+    if (!rpl_filter->db_ok(name()) ||
+        !rpl_filter->db_ok_with_wild_table(name()))
+    {
+      my_message(ER_SLAVE_IGNORED_TABLE, ER(ER_SLAVE_IGNORED_TABLE), MYF(0));
+      return true;
+    }
+  }
+  return false;
+}
+#endif
+
+
+int SQL::Statement::Schema::DDL_with_name::exec_direct(THD *thd) const
+{
+  if (Name::check_with_error())
+    return 0;
+#ifdef HAVE_REPLICATION
+  /*
+    If in a slave thread :
+    DROP DATABASE DB may not be preceded by USE DB.
+    For that reason, maybe db_ok() in sql/slave.cc did not check the 
+    do_db/ignore_db. And as this query involves no tables, tables_ok()
+    above was not called. So we have to check rules again here.
+  */
+  if (check_if_slave_ignored(thd))
+    return 0;
+#endif
+  if (check_access(thd))
+    return 0;
+  WSREP_TO_ISOLATION_BEGIN((char *) name(), NULL, NULL)
+  return exec(thd);
+
+error:
+  return -1;
+}
+
+
+/**
+  Upgrade slightly differs from the other DDL statements:
+  - returns a different value on slave when the database is ignored
+  - the order of Rpl_filter and Name valididy tests
+  - it additionally performs my_ok() on failure
+  QQ: Perhaps some of these differences are not really necessary
+*/
+int SQL::Statement::Schema::Upgrade::exec_direct(THD *thd) const
+{
+#ifdef HAVE_REPLICATION
+  if (check_if_slave_ignored(thd))
+    return 1;
+#endif
+  if (Name::check_with_error())
+    return 0;
+  if (check_access(thd))
+    return 1;
+  WSREP_TO_ISOLATION_BEGIN((char *) name(), NULL, NULL)
+  int res;
+  if (!(res= exec(thd)))
+    my_ok(thd);
+  return res;
+error:
+  return -1;
+}
diff --git a/sql/sql_db.h b/sql/sql_db.h
index 62d379c..dc62e6b 100644
--- a/sql/sql_db.h
+++ b/sql/sql_db.h
@@ -16,14 +16,12 @@
 #ifndef SQL_DB_INCLUDED
 #define SQL_DB_INCLUDED
 
+#include "sql_lang.h"
+#include "sql_acl.h"
 #include "hash.h"                               /* HASH */
 
 class THD;
 
-int mysql_create_db(THD *thd, char *db, HA_CREATE_INFO *create, bool silent);
-bool mysql_alter_db(THD *thd, const char *db, HA_CREATE_INFO *create);
-bool mysql_rm_db(THD *thd,char *db,bool if_exists, bool silent);
-bool mysql_upgrade_db(THD *thd, LEX_STRING *old_db);
 bool mysql_change_db(THD *thd, const LEX_STRING *new_db_name,
                      bool force_switch);
 
@@ -35,13 +33,178 @@ bool mysql_opt_change_db(THD *thd,
 bool my_dboptions_cache_init(void);
 void my_dboptions_cache_free(void);
 bool check_db_dir_existence(const char *db_name);
-bool load_db_opt(THD *thd, const char *path, HA_CREATE_INFO *create);
+bool load_db_opt(THD *thd, const char *path, Schema_specification_st *create);
 bool load_db_opt_by_name(THD *thd, const char *db_name,
-                         HA_CREATE_INFO *db_create_info);
+                         Schema_specification_st *db_create_info);
 CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name);
 bool my_dbopt_init(void);
 void my_dbopt_cleanup(void);
 
+
+namespace SQL {
+
+
+namespace Statement {
+
+
+namespace Schema {
+
+
+// Schema name
+class Name: public Identifier_normalized
+{
+public:
+  Name(const LEX_STRING &other) :Identifier_normalized(other) { }
+  Name(const LEX *lex) :Identifier_normalized(lex) { }
+#ifdef HAVE_REPLICATION
+  bool check_if_slave_ignored(THD *thd) const;
+#endif
+  bool check() const;
+  bool check_with_error() const;
+};
+
+
+// Schema definition options: IF EXISTS, IF NOT EXISTS
+class DDL_options: public DDL_options_st
+{
+public:
+  DDL_options() { init(); }
+  DDL_options(Options options)
+  {
+    set(options);
+  }
+  DDL_options(const DDL_options_st options)
+  {
+    set(options);
+  }
+  DDL_options(const LEX *lex);
+};
+
+
+// Schema specification, e.g. CHARACTER SET xxx
+class Specification: public Schema_specification_st
+{
+public:
+  Specification(const Schema_specification_st &info)
+   :Schema_specification_st(info)
+  { }
+  Specification(const LEX *lex);
+};
+
+
+/**
+  A common class for all Schema DDL options:
+  - CREATE SCHEMA
+  - DROP SCHEMA
+  - ALTER SCHEMA
+  - ALTER SCHEMA UPGRADE DATA DIRECTORY NAME
+*/
+class DDL: public Directly_executable
+{
+protected:
+  bool rm_db(THD *thd, const Name &name, bool if_exists, bool silent) const;
+
+  int create_db(THD *thd,
+                const Name &name,
+                const DDL_options_st options,
+                const Schema_specification_st &info,
+                bool silent) const;
+};
+
+
+class DDL_with_name: public DDL, public Name
+{
+  /*
+    Execute a DDL statement.
+    Assumes that Name has already been checked for validity.
+  */
+  virtual bool exec(THD *thd) const = 0;
+  virtual bool check_access(THD *) const = 0;
+protected:
+  DDL_with_name(const Name &name): Name(name) { }
+  DDL_with_name(const LEX *lex): Name(lex) { }
+public:
+  int exec_direct(THD *thd) const;
+};
+
+
+class DDL_with_name_and_options: public DDL_with_name, public DDL_options
+{
+protected:
+  DDL_with_name_and_options(const LEX *lex)
+    :DDL_with_name(lex), DDL_options(lex) { }
+  DDL_with_name_and_options(const Name &name)
+    :DDL_with_name(name), DDL_options() { }
+};
+
+
+class Create: public DDL_with_name_and_options, public Specification
+{
+  bool exec(THD *thd) const
+  {
+    return DDL::create_db(thd, *this, *this, *this, false);
+  }
+  bool check_access(THD *thd) const
+  {
+    return ::check_access(thd, CREATE_ACL, name(), NULL, NULL, 1, 0);
+  }
+public:
+  Create(const LEX *lex)
+    :DDL_with_name_and_options(lex), Specification(lex)
+  { }
+  Create(const Name &name, const Schema_specification_st &info)
+   :DDL_with_name_and_options(name), Specification(info)
+  { }
+};
+
+
+class Drop: public DDL_with_name_and_options
+{
+  bool exec(THD *thd) const
+  {
+    return rm_db(thd, *this, if_exists(), false);
+  }
+  bool check_access(THD *thd) const
+  {
+    return ::check_access(thd, DROP_ACL, name(), NULL, NULL, 1, 0);
+  }
+public:
+  Drop(const Name &name) :DDL_with_name_and_options(name) { }
+  Drop(const LEX *lex) :DDL_with_name_and_options(lex) { }
+};
+
+
+class Alter: public DDL_with_name, public Specification
+{
+  bool exec(THD *thd) const;
+  bool check_access(THD *thd) const
+  {
+    return ::check_access(thd, ALTER_ACL, name(), NULL, NULL, 1, 0);
+  }
+public:
+  Alter(const LEX *lex) :DDL_with_name(lex), Specification(lex) { }
+};
+
+
+class Upgrade: public DDL_with_name
+{
+  bool exec(THD *thd) const;
+  bool check_access(THD *thd) const
+  {
+    return ::check_access(thd, ALTER_ACL, name(),  NULL, NULL, 1, 0) ||
+           ::check_access(thd, DROP_ACL,  name(),  NULL, NULL, 1, 0)  ||
+           ::check_access(thd, CREATE_ACL, name(), NULL, NULL, 1, 0);
+  }
+public:
+  Upgrade(const LEX *lex) :DDL_with_name(lex) { }
+  int exec_direct(THD *thd) const;
+};
+
+
+} // End of namespace SQL::Statement::Schema
+} // End of namespace SQL::Statement
+} // End of namespace SQL
+
 #define MY_DB_OPT_FILE "db.opt"
 
 #endif /* SQL_DB_INCLUDED */
diff --git a/sql/sql_insert.cc b/sql/sql_insert.cc
index 92f5f52..54a1e70 100644
--- a/sql/sql_insert.cc
+++ b/sql/sql_insert.cc
@@ -3841,7 +3841,8 @@ void select_insert::abort_result_set() {
   @retval 0         Error
 */
 
-static TABLE *create_table_from_items(THD *thd, HA_CREATE_INFO *create_info,
+static TABLE *create_table_from_items(THD *thd,
+                                      Table_specification_st *create_info,
                                       TABLE_LIST *create_table,
                                       Alter_info *alter_info,
                                       List<Item> *items,
@@ -3924,7 +3925,7 @@ static TABLE *create_table_from_items(THD *thd, HA_CREATE_INFO *create_info,
 
   if (!mysql_create_table_no_lock(thd, create_table->db,
                                   create_table->table_name,
-                                  create_info, alter_info, NULL,
+                                  *create_info, alter_info, NULL,
                                   select_field_count))
   {
     DEBUG_SYNC(thd,"create_table_select_before_open");
@@ -4086,7 +4087,7 @@ static TABLE *create_table_from_items(THD *thd, HA_CREATE_INFO *create_info,
     row-based replication for the statement.  If we are creating a
     temporary table, we need to start a statement transaction.
   */
-  if (!thd->lex->create_info.tmp_table() &&
+  if (!thd->lex->tmp_table() &&
       thd->is_current_stmt_binlog_format_row() &&
       mysql_bin_log.is_open())
   {
@@ -4095,7 +4096,8 @@ static TABLE *create_table_from_items(THD *thd, HA_CREATE_INFO *create_info,
 
   DEBUG_SYNC(thd,"create_table_select_before_check_if_exists");
 
-  if (!(table= create_table_from_items(thd, create_info, create_table,
+  if (!(table= create_table_from_items(thd, create_info,
+                                       create_table,
                                        alter_info, &values,
                                        &extra_lock, hook_ptr)))
     /* abort() deletes table */
@@ -4178,8 +4180,8 @@ static TABLE *create_table_from_items(THD *thd, HA_CREATE_INFO *create_info,
   tmp_table_list.table = *tables;
   query.length(0);      // Have to zero it since constructor doesn't
 
-  result= show_create_table(thd, &tmp_table_list, &query, create_info,
-                            WITH_DB_NAME);
+  result= show_create_table(thd, &tmp_table_list, &query,
+                            create_info, WITH_DB_NAME);
   DBUG_ASSERT(result == 0); /* show_create_table() always return 0 */
 
   if (WSREP_EMULATE_BINLOG(thd) || mysql_bin_log.is_open())
diff --git a/sql/sql_lang.h b/sql/sql_lang.h
new file mode 100644
index 0000000..76a1340
--- /dev/null
+++ b/sql/sql_lang.h
@@ -0,0 +1,79 @@
+/* Copyright (c) 2014, MariaDB Foundation
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#ifndef SQL_LANG_INCLUDED
+#define SQL_LANG_INCLUDED
+
+namespace SQL {
+
+class Identifier: protected LEX_CSTRING
+{
+  void set(const LEX_STRING &other)
+  {
+    str= other.str;
+    length= other.length;
+    DBUG_ASSERT(str[length] == 0);
+  }
+public:
+  Identifier(const LEX_STRING &other)
+  {
+    set(other);
+  }
+  Identifier(const LEX *);
+  const char *name() const { return str; }
+  const size_t name_length() const { return length; }
+};
+
+
+class Identifier_normalized: public Identifier
+{
+  char m_buf[NAME_LEN + 1 + MYSQL50_TABLE_NAME_PREFIX_LENGTH + 10];
+  void normalize();
+public:
+  Identifier_normalized(const LEX_STRING &other)
+    :Identifier(other) { normalize(); }
+  Identifier_normalized(const LEX *lex)
+    :Identifier(lex) { normalize(); }
+};
+
+
+namespace Statement {
+
+
+/*
+  All SQL statements that can be executed directly.
+  Statement instances are created using the data in thd->lex,
+  previously populated by the SQL parser.
+*/
+class Directly_executable
+{
+public:
+  /*
+    Perform all stages of a direct SQL execution:
+    - Check for validity (e.g. name in "CREATE SCHEMA name" is valid).
+    - Check access
+    - Apply filters (e.g. Rpl_filters on slave)
+    - Perform WSREP_TO_ISOLATION
+    - Execute the actual action
+  */
+  virtual int exec_direct(THD *thd) const = 0;
+};
+
+} // End of namescpace Statement
+
+
+} // End of namespace SQL
+
+#endif /* SQL_LANG_INCLUDED */
diff --git a/sql/sql_lex.cc b/sql/sql_lex.cc
index 7eb38b1..45ba8be 100644
--- a/sql/sql_lex.cc
+++ b/sql/sql_lex.cc
@@ -122,6 +122,13 @@ inline int lex_casecmp(const char *s, const char *t, uint len)
   return (int) len+1;
 }
 
+
+SQL::Identifier::Identifier(const LEX *lex)
+{
+  set(lex->name);
+}
+
+
 #include <lex_hash.h>
 
 
@@ -512,6 +519,7 @@ void lex_start(THD *thd)
   lex->use_only_table_context= FALSE;
   lex->parse_vcol_expr= FALSE;
   lex->check_exists= FALSE;
+  lex->create_info.lex_start();
   lex->verbose= 0;
 
   lex->name= null_lex_str;
diff --git a/sql/sql_lex.h b/sql/sql_lex.h
index b18cff1..fc61ac1 100644
--- a/sql/sql_lex.h
+++ b/sql/sql_lex.h
@@ -21,6 +21,7 @@
 #ifndef SQL_LEX_INCLUDED
 #define SQL_LEX_INCLUDED
 
+#include "sql_lang.h"
 #include "violite.h"                            /* SSL_type */
 #include "sql_trigger.h"
 #include "item.h"               /* From item_subselect.h: subselect_union_engine */
@@ -2427,7 +2428,7 @@ struct LEX: public Query_tables_list
   Item_sum *in_sum_func;
   udf_func udf;
   HA_CHECK_OPT   check_opt;			// check/repair options
-  HA_CREATE_INFO create_info;
+  Table_specification_st create_info;
   KEY_CREATE_INFO key_create_info;
   LEX_MASTER_INFO mi;				// used by CHANGE MASTER
   LEX_SERVER_OPTIONS server_options;
@@ -2507,7 +2508,7 @@ struct LEX: public Query_tables_list
   uint16 create_view_algorithm;
   uint8 create_view_check;
   uint8 context_analysis_only;
-  bool drop_temporary, local_file;
+  bool local_file;
   bool check_exists;
   bool autocommit;
   bool verbose, no_write_to_binlog;
@@ -2775,6 +2776,40 @@ struct LEX: public Query_tables_list
 
   int print_explain(select_result_sink *output, uint8 explain_flags,
                     bool is_analyze, bool *printed_anything);
+
+  void set_command(enum_sql_command command,
+                   DDL_options_st options)
+  {
+    sql_command= command;
+    create_info.set(options);
+  }
+  void set_command(enum_sql_command command,
+                   uint scope,
+                   DDL_options_st options)
+  {
+    set_command(command, options);
+    create_info.options|= scope; // HA_LEX_CREATE_TMP_TABLE or 0
+  }
+  bool set_command_with_check(enum_sql_command command,
+                              uint scope,
+                              DDL_options_st options)
+  {
+    if (options.or_replace() && options.if_not_exists())
+    {
+      my_error(ER_WRONG_USAGE, MYF(0), "OR REPLACE", "IF NOT EXISTS");
+      return true;
+    }
+    set_command(command, scope, options);
+    return false;
+  }
+  /*
+    DROP shares lex->create_info to store TEMPORARY and IF EXISTS options
+    to save on extra initialization in lex_start().
+    Add some wrappers, to avoid direct use of lex->create_info in the
+    caller code processing DROP statements (which might look confusing).
+  */
+  bool tmp_table() const { return create_info.tmp_table(); }
+  bool if_exists() const { return create_info.if_exists(); }
 };
 
 
